"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DefaultOpts = void 0;
var _ = _interopRequireWildcard(require("lodash"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var DefaultOpts = /*#__PURE__*/_createClass(function DefaultOpts(monaco) {
  var _this = this;
  _classCallCheck(this, DefaultOpts);
  _defineProperty(this, "monacoEditorVersion", '0.15.6');
  _defineProperty(this, "parserType", 'odps');
  _defineProperty(this, "language", 'sql');
  _defineProperty(this, "onParse", function (parseResult) {
    //
  });
  _defineProperty(this, "onSuggestTableNames", function (cursorInfo) {
    return Promise.resolve(['dt', 'b2b', 'tmall'].map(function (name) {
      return {
        label: name,
        insertText: name,
        sortText: "A".concat(name),
        kind: _this.monaco.languages.CompletionItemKind.Folder
      };
    }));
  });
  _defineProperty(this, "onSuggestTableFields", function (tableInfo) {
    return Promise.resolve(['aa', 'bb', 'cc'].map(function (eachName) {
      return _.get(tableInfo, 'namespace.value', '') + _.get(tableInfo, 'tableName.value', '') + eachName;
    }).map(function (fieldName) {
      return {
        label: fieldName,
        insertText: fieldName,
        sortText: "B".concat(fieldName),
        kind: _this.monaco.languages.CompletionItemKind.Field
      };
    }));
  });
  _defineProperty(this, "pipeKeywords", function (keywords) {
    return keywords.filter(function (matching) {
      return matching.type === 'string';
    }).map(function (matching) {
      var value = /[a-zA-Z]+/.test(matching.value.toString()) ? _.upperCase(matching.value.toString()) : matching.value.toString();
      return {
        label: value,
        insertText: value,
        documentation: 'documentation',
        detail: 'detail',
        kind: _this.monaco.languages.CompletionItemKind.Keyword,
        sortText: "W".concat(matching.value)
      };
    });
  });
  _defineProperty(this, "onSuggestFunctionName", function (inputValue) {
    return Promise.resolve(['sum', 'count'].map(function (each) {
      return {
        label: each,
        insertText: each,
        sortText: "C".concat(each),
        kind: _this.monaco.languages.CompletionItemKind.Function
      };
    }));
  });
  _defineProperty(this, "onSuggestFieldGroup", function (tableNameOrAlias) {
    return {
      label: tableNameOrAlias,
      insertText: tableNameOrAlias,
      sortText: "D".concat(tableNameOrAlias),
      kind: _this.monaco.languages.CompletionItemKind.Folder
    };
  });
  _defineProperty(this, "onHoverTableField", function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    return Promise.resolve([{
      value: 'onHoverTableField'
    }, {
      value: "```json\n".concat(JSON.stringify(args, null, 2), "\n```")
    }]);
  });
  _defineProperty(this, "onHoverTableName", function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    return Promise.resolve([{
      value: 'onHoverTableName'
    }, {
      value: "```json\n".concat(JSON.stringify(args, null, 2), "\n```")
    }]);
  });
  _defineProperty(this, "onHoverFunctionName", function () {
    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }
    return Promise.resolve([{
      value: 'onHoverFunctionName'
    }, {
      value: "```json\n".concat(JSON.stringify(args, null, 2), "\n```")
    }]);
  });
  this.monaco = monaco;
} //
);
exports.DefaultOpts = DefaultOpts;
//# sourceMappingURL=default-opts.js.map