"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "IToken", {
  enumerable: true,
  get: function get() {
    return _token.IToken;
  }
});
exports.createLexer = void 0;
var _token = require("./token");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var Tokenizer = /*#__PURE__*/function () {
  // eslint-disable-next-line no-useless-constructor, @typescript-eslint/no-parameter-properties
  function Tokenizer(lexerConfig) {
    _classCallCheck(this, Tokenizer);
    this.lexerConfig = lexerConfig;
  } //
  _createClass(Tokenizer, [{
    key: "tokenize",
    value: function tokenize(input) {
      var tokens = [];
      var token;
      var lastPosition = 0;

      // Keep processing the string until it is empty
      while (input.length) {
        // Get the next token and the token type
        var result = this.getNextToken(input);
        if (!result || !result.token) {
          throw Error("Lexer: Unexpected string \"".concat(input, "\"."));
        }

        // eslint-disable-next-line prefer-destructuring
        token = result.token;
        if (!token.value) {
          throw Error("Lexer: Regex parse error, please check your lexer config.");
        }
        token.position = [lastPosition, lastPosition + token.value.length - 1];
        lastPosition += token.value.length;

        // Advance the string
        // eslint-disable-next-line no-param-reassign
        input = input.substring(token.value.length);
        if (!result.config.ignore) {
          tokens.push(token);
        }
      }
      return tokens;
    }
  }, {
    key: "getNextToken",
    value: function getNextToken(input) {
      var _iterator = _createForOfIteratorHelper(this.lexerConfig),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var eachLexer = _step.value;
          var _iterator2 = _createForOfIteratorHelper(eachLexer.regexes),
            _step2;
          try {
            for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
              var regex = _step2.value;
              var token = this.getTokenOnFirstMatch({
                input: input,
                type: eachLexer.type,
                regex: regex
              });
              if (token) {
                return {
                  token: token,
                  config: eachLexer
                };
              }
            }
          } catch (err) {
            _iterator2.e(err);
          } finally {
            _iterator2.f();
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      return null;
    }
  }, {
    key: "getTokenOnFirstMatch",
    value: function getTokenOnFirstMatch(_ref) {
      var input = _ref.input,
        type = _ref.type,
        regex = _ref.regex;
      var matches = input.match(regex);
      if (matches) {
        // eslint-disable-next-line @typescript-eslint/no-object-literal-type-assertion
        return {
          type: type,
          value: matches[1]
        };
      }
    }
  }]);
  return Tokenizer;
}();
var createLexer = function createLexer(lexerConfig) {
  return function (text) {
    return new Tokenizer(lexerConfig).tokenize(text);
  };
};
exports.createLexer = createLexer;
//# sourceMappingURL=index.js.map