"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parserMap = exports.VisiterStore = exports.VisiterOption = exports.TreeNode = exports.Parser = exports.MatchNode = exports.MAX_VISITER_CALL = exports.FunctionNode = exports.CreateParserOptions = exports.ChainNode = void 0;
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
// tslint:disable:max-classes-per-file

// IToken | Array<IToken> | any return object from resolveAst().

// ////////////////////////////////////// Const or Variables

var parserMap = new Map();
exports.parserMap = parserMap;
var MAX_VISITER_CALL = 1000000;
exports.MAX_VISITER_CALL = MAX_VISITER_CALL;
var Parser = /*#__PURE__*/_createClass(function Parser() {
  _classCallCheck(this, Parser);
  _defineProperty(this, "rootChainNode", null);
  _defineProperty(this, "firstSet", new Map());
  _defineProperty(this, "firstOrFunctionSet", new Map());
  _defineProperty(this, "relatedSet", new Map());
});
exports.Parser = Parser;
var VisiterStore = /*#__PURE__*/_createClass(
// eslint-disable-next-line no-useless-constructor, @typescript-eslint/no-parameter-properties
function VisiterStore(scanner, parser) {
  _classCallCheck(this, VisiterStore);
  _defineProperty(this, "restChances", []);
  _defineProperty(this, "stop", false);
  this.scanner = scanner;
  this.parser = parser;
} //
);
exports.VisiterStore = VisiterStore;
var VisiterOption = /*#__PURE__*/_createClass(function VisiterOption() {
  _classCallCheck(this, VisiterOption);
  _defineProperty(this, "generateAst", true);
  _defineProperty(this, "enableFirstSet", true);
});
exports.VisiterOption = VisiterOption;
var ChainNode = /*#__PURE__*/_createClass(
// Eg: const foo = chain => chain()(), so the chain creatorFunction is 'foo'.

// eslint-disable-next-line no-useless-constructor, @typescript-eslint/no-parameter-properties
function ChainNode(parentIndex) {
  _classCallCheck(this, ChainNode);
  _defineProperty(this, "childs", []);
  _defineProperty(this, "astResults", []);
  _defineProperty(this, "creatorFunction", null);
  _defineProperty(this, "solveAst", null);
  this.parentIndex = parentIndex;
} //
);
exports.ChainNode = ChainNode;
var TreeNode = /*#__PURE__*/_createClass(
// eslint-disable-next-line no-useless-constructor, @typescript-eslint/no-parameter-properties
function TreeNode(parentIndex) {
  _classCallCheck(this, TreeNode);
  _defineProperty(this, "childs", []);
  this.parentIndex = parentIndex;
} //
);
exports.TreeNode = TreeNode;
var FunctionNode = /*#__PURE__*/_createClass(
// eslint-disable-next-line no-useless-constructor, @typescript-eslint/no-parameter-properties
function FunctionNode(chainFunction, parentIndex, parser) {
  var _this = this;
  _classCallCheck(this, FunctionNode);
  _defineProperty(this, "run", function () {
    return _this.chainFunction()(_this.parentNode, _this.chainFunction, _this.parentIndex, _this.parser);
  });
  this.chainFunction = chainFunction;
  this.parentIndex = parentIndex;
  this.parser = parser;
} //
);
exports.FunctionNode = FunctionNode;
var MatchNode = /*#__PURE__*/_createClass(
// eslint-disable-next-line no-useless-constructor, @typescript-eslint/no-parameter-properties
function MatchNode(matchFunction, matching, parentIndex) {
  var _this2 = this;
  _classCallCheck(this, MatchNode);
  _defineProperty(this, "run", function (scanner) {
    var isCostToken = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    return _this2.matchFunction(scanner, isCostToken);
  });
  this.matchFunction = matchFunction;
  this.matching = matching;
  this.parentIndex = parentIndex;
} //
);
exports.MatchNode = MatchNode;
var CreateParserOptions = /*#__PURE__*/_createClass(function CreateParserOptions() {
  _classCallCheck(this, CreateParserOptions);
  _defineProperty(this, "cursorTokenExcludes", function () {
    return false;
  });
});
exports.CreateParserOptions = CreateParserOptions;
//# sourceMappingURL=define.js.map