"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.plus = exports.optional = exports.matchTrue = exports.matchTokenType = exports.matchFalse = exports.match = exports.many = void 0;
var _chain = require("./chain");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function equalWordOrIncludeWords(str, word) {
  if (typeof word === 'string') {
    return judgeMatch(str, word);
  }
  return word.some(function (eachWord) {
    return judgeMatch(str, eachWord);
  });
}
function judgeMatch(source, target) {
  if (source === null) {
    return false;
  }
  return (source && source.toLowerCase()) === (target && target.toLowerCase());
}
function matchToken(scanner, compare, isCostToken) {
  var token = scanner.read();
  if (!token) {
    return {
      token: null,
      match: false
    };
  }
  if (compare(token)) {
    if (isCostToken) {
      scanner.next();
    }
    return {
      token: token,
      match: true
    };
  }
  return {
    token: token,
    match: false
  };
}
function createMatch(fn, specialName) {
  return function (arg) {
    function foo() {
      return function (scanner, isCostToken) {
        return fn(scanner, arg, isCostToken);
      };
    }
    foo.parserName = 'match';
    foo.displayName = specialName;
    return foo;
  };
}
var match = createMatch(function (scanner, word, isCostToken) {
  return matchToken(scanner, function (token) {
    return equalWordOrIncludeWords(token.value, word);
  }, isCostToken);
});
exports.match = match;
var matchTokenType = function matchTokenType(tokenType) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var options = _objectSpread({
    includes: [],
    excludes: []
  }, opts);
  return createMatch(function (scanner, word, isCostToken) {
    return matchToken(scanner, function (token) {
      if (options.includes.some(function (includeValue) {
        return judgeMatch(includeValue, token.value);
      })) {
        return true;
      }
      if (options.excludes.some(function (includeValue) {
        return judgeMatch(includeValue, token.value);
      })) {
        return false;
      }
      if (token.type !== tokenType) {
        return false;
      }
      return true;
    }, isCostToken);
  }, tokenType)();
};
exports.matchTokenType = matchTokenType;
var matchTrue = function matchTrue() {
  return {
    token: null,
    match: true
  };
};
exports.matchTrue = matchTrue;
var matchFalse = function matchFalse() {
  return {
    token: null,
    match: true
  };
};
exports.matchFalse = matchFalse;
var optional = function optional() {
  for (var _len = arguments.length, elements = new Array(_len), _key = 0; _key < _len; _key++) {
    elements[_key] = arguments[_key];
  }
  if (elements.length === 0) {
    throw Error('Must have arguments!');
  }
  return (0, _chain.chain)([_chain.chain.apply(void 0, elements)(function (ast) {
    return elements.length === 1 ? ast[0] : ast;
  }), true])(function (ast) {
    return ast[0];
  });
};
exports.optional = optional;
var plus = function plus() {
  for (var _len2 = arguments.length, elements = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    elements[_key2] = arguments[_key2];
  }
  if (elements.length === 0) {
    throw Error('Must have arguments!');
  }
  var plusFunction = function plusFunction() {
    return (0, _chain.chain)(_chain.chain.apply(void 0, elements)(function (ast) {
      return elements.length === 1 ? ast[0] : ast;
    }), optional(plusFunction))(function (ast) {
      if (ast[1]) {
        return [ast[0]].concat(ast[1]);
      }
      return [ast[0]];
    });
  };
  return plusFunction;
};
exports.plus = plus;
var many = function many() {
  if (arguments.length === 0) {
    throw Error('Must have arguments!');
  }
  return optional(plus.apply(void 0, arguments));
};
exports.many = many;
//# sourceMappingURL=match.js.map