"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Scanner = void 0;
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var Scanner = /*#__PURE__*/_createClass(function Scanner(tokens) {
  var _this = this;
  var _index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  _classCallCheck(this, Scanner);
  _defineProperty(this, "tokens", []);
  _defineProperty(this, "index", 0);
  _defineProperty(this, "read", function () {
    var token = _this.tokens[_this.index];
    if (token) {
      return token;
    }
    return false;
  });
  _defineProperty(this, "next", function () {
    _this.index += 1;
  });
  _defineProperty(this, "isEnd", function () {
    return _this.index >= _this.tokens.length;
  });
  _defineProperty(this, "getIndex", function () {
    return _this.index;
  });
  _defineProperty(this, "setIndex", function (index) {
    _this.index = index;
    return index;
  });
  _defineProperty(this, "getRestTokenCount", function () {
    return _this.tokens.length - _this.index - 1;
  });
  _defineProperty(this, "getNextByToken", function (token) {
    var currentTokenIndex = _this.tokens.findIndex(function (eachToken) {
      return eachToken === token;
    });
    if (currentTokenIndex > -1) {
      if (currentTokenIndex + 1 < _this.tokens.length) {
        return _this.tokens[currentTokenIndex + 1];
      }
      return null;
    }
    throw Error("token ".concat(token.value.toString(), " not exist in scanner."));
  });
  _defineProperty(this, "getTokenByCharacterIndex", function (characterIndex) {
    if (characterIndex === null) {
      return null;
    }
    var _iterator = _createForOfIteratorHelper(_this.tokens),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var token = _step.value;
        if (characterIndex >= token.position[0] && characterIndex - 1 <= token.position[1]) {
          return token;
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    return null;
  });
  _defineProperty(this, "getPrevTokenByCharacterIndex", function (characterIndex) {
    var prevToken = null;
    var prevTokenIndex = null;
    _this.tokens.forEach(function (token, index) {
      if (token.position[1] < characterIndex - 1) {
        prevToken = token;
        prevTokenIndex = index;
      }
    });
    return {
      prevToken: prevToken,
      prevTokenIndex: prevTokenIndex
    };
  });
  _defineProperty(this, "getNextTokenFromCharacterIndex", function (characterIndex) {
    var _iterator2 = _createForOfIteratorHelper(_this.tokens),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var token = _step2.value;
        if (token.position[0] > characterIndex) {
          return token;
        }
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    return null;
  });
  _defineProperty(this, "addToken", function (token) {
    var _this$getPrevTokenByC = _this.getPrevTokenByCharacterIndex(token.position[0]),
      prevToken = _this$getPrevTokenByC.prevToken,
      prevTokenIndex = _this$getPrevTokenByC.prevTokenIndex;
    if (prevToken) {
      // prevTokenIndex
      _this.tokens.splice(prevTokenIndex + 1, 0, token);
    } else {
      _this.tokens.unshift(token);
    }
  });
  // ignore whitespace, comment
  this.tokens = tokens.slice();
  this.index = _index;
});
exports.Scanner = Scanner;
//# sourceMappingURL=scanner.js.map