"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compareIgnoreLowerCaseWhenString = exports.binaryRecursionToArray = void 0;
exports.getPathByCursorIndexFromAst = getPathByCursorIndexFromAst;
exports.tailCallOptimize = tailCallOptimize;
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var compareIgnoreLowerCaseWhenString = function compareIgnoreLowerCaseWhenString(source, target) {
  if (typeof source === 'string' && typeof target === 'string') {
    return source.toLowerCase() === target.toLowerCase();
  }
  return source === target;
};
exports.compareIgnoreLowerCaseWhenString = compareIgnoreLowerCaseWhenString;
var binaryRecursionToArray = function binaryRecursionToArray(ast) {
  if (ast[1]) {
    return [ast[0]].concat(ast[1][1]);
  }
  return [ast[0]];
};
exports.binaryRecursionToArray = binaryRecursionToArray;
function tailCallOptimize(f) {
  var value;
  var active = false;
  var accumulated = [];
  return function accumulator() {
    // eslint-disable-next-line prefer-rest-params
    accumulated.push(arguments);
    if (!active) {
      active = true;
      while (accumulated.length) {
        // eslint-disable-next-line babel/no-invalid-this
        value = f.apply(this, accumulated.shift());
      }
      active = false;
      return value;
    }
  };
}
function getPathByCursorIndexFromAst(obj, cursorIndex, path) {
  // eslint-disable-next-line no-param-reassign
  path = path || '';
  var fullpath = '';
  // eslint-disable-next-line guard-for-in
  for (var key in obj) {
    if (obj[key] && obj[key].token === true && obj[key].position[0] <= cursorIndex && obj[key].position[1] + 1 >= cursorIndex) {
      if (path === '') {
        return key;
      }
      return "".concat(path, ".").concat(key);
    }
    if (_typeof(obj[key]) === 'object') {
      fullpath = getPathByCursorIndexFromAst(obj[key], cursorIndex, path === '' ? key : "".concat(path, ".").concat(key)) || fullpath;
    }
  }
  return fullpath;
}
//# sourceMappingURL=utils.js.map